<template>
  <div>
    <BarChart :chart-data="datacollection" :options="options" :height="300" />
  </div>
</template>

<script>
import BarChart from '@/components/chart/bar.js'
import covertDate from '@/mixins/formateDate'
export default {
  mixins: [covertDate],
  components: {
    BarChart,
  },
  props: {
    setDataDate: Number,
    amountDay: Number,
  },
  data() {
    return {
      datacollection: null,
      loaded: false,
      setTotalData: [],
      setLabel: [],
      setBGColor: [],
      options: null,
    }
  },
  mounted() {
    this.fillData()
    this.getDataAxios()
  },
  watch: {
    setDataDate(newVal, oldVal) {
      this.getDataAxios(
        this.setDataDate,
        this.$nuxt.$store.state.expensestable.ExpensesTable,
        this.$nuxt.$store.state.expensestype.ExpensesType
      )
    },
  },
  methods: {
    fillData() {
      this.datacollection = {
        labels: this.setLabel,
        datasets: [
          {
            backgroundColor: this.setBGColor,
            data: this.setTotalData,
            borderColor: ['#FFF'],
            borderWidth: 1,
          },
        ],
      }
      this.options = {
        legend: {
          display: false,
          labels: {
            fontColor: 'rgb(255, 99, 132)',
          },
        },
        plugins: {
          datalabels: {
            formatter: function (value) {
              if (value == 0) {
                return ''
              }
              return parseInt(value).toLocaleString('th-TH', {
                style: 'currency',
                currency: 'THB',
              })
            },
            color: 'blue',
            labels: {
              title: { color: 'blue', font: { weight: 'bold' } },
              value: { color: 'green' },
            },
          },
        },

        responsive: true,
        maintainAspectRatio: false,
        height: '350',
        width: '200',
        scales: {
          fontColor: '#8a18e7',
          fontSize: 20,
          yAxes: [
            {
              fontColor: '#8a18e7',
              fontSize: 20,
              ticks: {
                beginAtZero: true,
                min: 0,
                stepSize: 500,
              },
            },
          ],
        },
      }
    },
    async getDataAxios(
      timeVal = new Date().getTime(),
      expensestable = 0,
      expensestype = 0
    ) {
      if (expensestable) {
        const getDate = timeVal

        const dataRes = this.totalTypeMulti(expensestable, getDate, getDate)

        this.setLabel = expensestype.map((x) => x.name)
        const countName = expensestype.map((x) => x.name).length

        this.setTotalData = this.setArray(dataRes, countName)

        this.setBGColor = this.setObjectBG(countName)

        this.fillData()
      }
    },
    setArray(dataObject, countName) {
      const arrayDeserts = new Array(countName)

      for (let i = 0; i < countName; i++) {
        dataObject.forEach((res) => {
          if (res.id - 1 == i) {
            if (arrayDeserts[i] > 0) {
              arrayDeserts[i] = arrayDeserts[i] + res.price
            } else {
              arrayDeserts[i] = res.price
            }
          }
        })
        if (arrayDeserts[i] == null) {
          arrayDeserts[i] = ''
        }
      }
      return arrayDeserts
    },
  },
}
</script>
